//////////////////////////////////////////////////////////////////////////
// UVRip 1.05 by Bendy's 3D Systems
// Copyright (c) 1999
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// The complete GNU public license can be found in this directory.
//
// Explicit permission is given to link this file with the 
// tsxapi.lib library supplied with the trueSpace API
// Software Developers Kit
//////////////////////////////////////////////////////////////////////////
// Header file for the main dialog box. Automatically
// created by Microsoft Developer Studio.


#if !defined(AFX_TSXDIALOG_H__C8C7023C_75B4_11D1_816E_000001069287__INCLUDED_)
#define AFX_TSXDIALOG_H__C8C7023C_75B4_11D1_816E_000001069287__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000
// TSXDIALOG.h : header file
//

// We need to prototype the data types that the 
// dialog class uses
struct	tsxSOBJ;
struct	tsxPOLYHEDRON;
struct	CtsxUV;


#include "ColorButton.h"
#include "RipWnd.h"

#define	minmax(val,min,max) (((val)<(min))?(min):(((val)>(max))?(max):(val)))
/////////////////////////////////////////////////////////////////////////////
// CTSXDIALOG dialog

class CTSXDIALOG : public CDialog
{
// Construction
public:

	CTSXDIALOG();   // standard constructor
	
	BOOL Create();	// Function called when dialog created

	// Variables to store the information in the 
	// dialog box

	// Dialog Data
	//{{AFX_DATA(CTSXDIALOG)
	enum { IDD = IDD_DIALOG1 };
	CRipWnd	m_preview;
	CColorButton	m_fgcol;
	CColorButton	m_bgcol;
	UINT	m_x;
	UINT	m_y;
	CString	m_objname;
	BOOL	m_remap;
	BOOL	m_antialias;
	float	m_linewidth;
	float	m_alias;
	int		m_fgalpha;
	int		m_bgalpha;
	//}}AFX_DATA

protected:

	// Additional variables need by UVRip
	CtsxUV			*uv;			// Place to store UV map
	int				n_uv,n_edges;	// # of entries in UV
									// # unique edges
	CEdgeList		edges;		// List of edges
	
	// Member function to draw UV lines.
	void drawUVLine(rgba *image, int wid, int hgt, float xa, float ya, float xb, float yb);

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CTSXDIALOG)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual BOOL OnCommand(WPARAM wParam, LPARAM lParam);
	//}}AFX_VIRTUAL


// Implementation
protected:

	// Generated message map functions
	//{{AFX_MSG(CTSXDIALOG)
	virtual void OnCancel();
	afx_msg void OnUpdate();
	afx_msg void OnSave();
	afx_msg void OnForecol();
	afx_msg void OnBackcol();
	afx_msg void OnAliascheck();
	virtual BOOL OnInitDialog();
	afx_msg void OnDeltaposSpinfgalpha(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDeltaposSpinbgalpha(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnKillfocusFgalpha();
	afx_msg void OnKillfocusBgalpha();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void newPreviewImage();
	void drawUVMap(rgba *img,int wid, int hgt, float aawid, float aaalias);
	inline int isSelectedPoly(tsxSOBJ *obj);
};
#endif // !defined(AFX_TSXDIALOG_H__C8C7023C_75B4_11D1_816E_000001069287__INCLUDED_)
