//////////////////////////////////////////////////////////////////////////
// UVRip 1.05 by Bendy's 3D Systems
// Copyright (c) 1999
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// The complete GNU public license can be found in this directory.
//
// Explicit permission is given to link this file with the 
// tsxapi.lib library supplied with the trueSpace API
// Software Developers Kit
//////////////////////////////////////////////////////////////////////////
// Implementation of a functions to manipulate rgba values.

// Sorry, no detailed comments
#include "stdafx.h"
#include "rgba.h"
#include <math.h>

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// overloaded == operator for RGB
int
operator==(rgba col1, rgba col2)
{
	return (col1.r==col2.r)&&(col1.g==col2.g)&&
		(col1.b==col2.b) && (col1.a==col2.a);
}

// drawLine function to draw lines
//
// drawLine(image,color,x_sz,y_sz,xa,ya,xb,yb);
//
//	image		RGB pointer to the image being drawn on
//	color		RGB color to draw
//	x_sz,y_sz	x,y size of the image
//	xa,ya		coordinates of start of line
//	xb,yb		coordinates of end of line
//
// Draws a line on 'image' (size (x_sz,y_sz)) from (xa,ya)
// to (xb,yb)
// Bresenhams algorithm is used.
// Taken from Graphic Gems, Academic Press 1990
void
rgbadrawLine(rgba *image, rgba color, int x_sz, int y_sz, int xa, int ya, int xb, int yb)
{
	int	d, x, y, ax, ay, sx, sy, dx, dy;

	dx = xb-xa; ax = bres_abs(dx)<<1; sx = bres_sgn(dx);
	dy = yb-ya; ay = bres_abs(dy)<<1; sy = bres_sgn(dy);

	x = xa;
	y = ya;
	if (ax>ay)	// X Dominant
	{
		d= ay-(ax>>1);
		for (;;)
		{
			if ((y>=0 && y < y_sz) && (x>=0 && x< x_sz))
				rgbaSetColor(image[y*x_sz+x],color);
			if (x==xb) return;
			if (d>=0)
			{
				y += sy;
				d -= ax;
			}
			x += sx;
			d += ay;
		}
	}
	else		// Y Dominant
	{
		d = ax-(ay>>1);
		for (;;)
		{
			if ((y>=0 && y < y_sz) && (x>=0 && x< x_sz))
				rgbaSetColor(image[y*x_sz+x],color);
			if (y==yb) return;
			if (d>=0)
			{
				x += sx;
				d -= ay;
			}
			y += sy;
			d += ax;
		}
	}
}
