//////////////////////////////////////////////////////////////////////////
// UVRip 1.05 by Bendy's 3D Systems
// Copyright (c) 1999
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
// 
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// The complete GNU public license can be found in this directory.
//
// Explicit permission is given to link this file with the 
// tsxapi.lib library supplied with the trueSpace API
// Software Developers Kit
//////////////////////////////////////////////////////////////////////
#if !defined(RGBADEF)
#define RGBADEF
typedef struct	rgba {
	//unsigned char	b,g,r,a;
	unsigned char	b,g,r,a;
	rgba(unsigned char r1=0,unsigned char g1=0,unsigned char b1=0,unsigned char a1=0) {r=r1;g=g1;b=b1;a=a1;};
	rgba(rgba &c){r=c.r;g=c.g;b=c.b;a=c.a;};
	void colorref(COLORREF c) {r = GetRValue(c);g = GetGValue(c);b = GetBValue(c);};
	COLORREF	Brgb() { return RGB(r,g,b);};
	// blend(c,f): blends color c with this colour. f is factor for *this colour.
	void blend(rgba c, float f) {r = (unsigned char)((1-f) * c.r + f * r);
							g = (unsigned char)((1-f) * c.g + f * g);
							b = (unsigned char)((1-f) * c.b + f * b);
							a = (unsigned char)((1-f) * c.a + f * a); };
	rgba& operator=(const rgba &rhs) { r=rhs.r;g=rhs.g;b=rhs.b;a=rhs.a;return *this;};
} rgba;

#define rgbaSetColor(image,col) { memcpy(&(image),&(col),4); }

// Definitions used by line draw function
// bres_sgn(x) returns the sign of x
// bres_abs(x) returns 1 if x>=0 and -1 otherwise
// I know these exist as library functions but this
// way I know they're efficient.
#define	bres_sgn(x)	(((x)<0)?-1:1)
#define	bres_abs(x)	(((x)<0)?-(x):(x))

// Function prototypes

// overloaded == operator for RGB
int operator==(struct rgba col1, struct rgba col2);

// drawLine function
void	rgbadrawLine(rgba *, rgba, int ,int, int, int, int, int);

#endif